Draft BSpline

From FreeCAD Documentation
Revision as of 02:54, 8 November 2018 by Vocx (talk | contribs) (More information for the options)

Draft BSpline

Menu location
Draft → BSpline
Workbenches
Draft, Arch
Default shortcut
B S
Introduced in version
-
See also
Draft Wire, Draft Line

Description

The BSpline tool creates a B-Spline curve from several points in the current work plane. It uses the Draft Linestyle set on the Draft Tray. The BSpline tool behaves like the Draft Wire tool, but is curved.

How to use

  1. Press the Draft BSpline button, or press B then S keys
  2. Click a first point on the 3D view, or type a coordinate
  3. Click additional point on the 3D view, or type a coordinate

Options

  • Press A or the Finish button to finish the spline, leaving it open.
  • Press O or the Close button to close the spline, that is, a curve will be added from the last point to the first one to form a face. At least three points are required to form a face.
  • Press W or the Wipe button to remove the curve segments already placed, but keep editing the spline from the last point.
  • Press U or the Set WP button to adjust the current working plane in the orientation of the last point.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the BSpline tool will restart after you finish the spline, allowing you to draw another one without pressing the tool button again.
  • Press L or click the checkbox to toggle filled mode. If filled mode is on, a closed spline will create a filled face (DataMake Face true); if not, the closed spline will not make a face (DataMake Face false).
  • Press Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Press Shift while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press Ctrl+Z or press the Undo button to undo the last point.
  • Press Esc or the Cancel button to abort the current command; curve segments already placed will remain.

Properties

  • DataClosed: Specifies if the spline is closed or not
  • DataMake Face: Fills the spline with a face
  • ViewEnd Arrow: Shows an arrow symbol at the last point of the spline, so it can be used as an annotation leader line
  • ViewPattern: Specifies a hatch pattern to fill the wire with
  • ViewPattern Size: Specifies the size of the hatch pattern

Scripting

The BSpline tool can by used in macros and from the python console by using the following function:

makeBSpline (pointslist,[closed],[placement])
  • Creates a B-Spline object from the given list of vectors.
  • If closed is True or first and last points are identical, the wire is closed.
  • If face is true (and the bspline is closed), the bspline will appear filled.
  • Instead of a list of points, you can also pass a Part Wire.
  • Returns the newly created object.

Example:

import FreeCAD,Draft
p1 = FreeCAD.Vector(0,0,0)
p2 = FreeCAD.Vector(1,1,0)
p3 = FreeCAD.Vector(2,0,0)
Draft.makeBSpline([p1,p2,p3],closed=True)